package app.yodha.etl.httplogstodb

import org.apache.camel.Exchange
import org.apache.camel.builder.endpoint.dsl.CronEndpointBuilderFactory.cron
import org.apache.camel.quarkus.kotlin.routes
import org.eclipse.microprofile.config.inject.ConfigProperty
import javax.enterprise.context.ApplicationScoped
import javax.enterprise.inject.Produces

@ApplicationScoped
class Routes(
    @ConfigProperty(name = "httpsLogsToDb.cron", defaultValue = "0 0/1 * * * ? *")
    val cron: String
) {

    @Produces
    fun buildRoutes() = routes {
        from(cron("httpsLogsToDb").schedule(cron))
            .process { e: Exchange -> e.message.body = "Hello from Kotlin!" }
            .log("\${body}")
    }
}
